/*
    FEARLUS model0-5-1-5: ClassInfo.h
    Copyright (C) 1999-2004  Macaulay Institute

    This file is part of FEARLUS model0-5-1-5, an agent-based model of land use
    change.

    FEARLUS model0-5-1-5 is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    FEARLUS model0-5-1-5 is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details. (LICENCE file in
    this directory.)

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Contact information:
      Gary Polhill,
      Macaulay Institute, Craigiebuckler, Aberdeen, AB15 8QH. United Kingdom
      g.polhill@macaulay.ac.uk
*/
/*


This is the interface for the ClassInfo class -- a global object class
initialised in main.m. It creates a list of classes in the simulation, and
can be called to fill out a list of classes that follow a particular protocol.
It's interface consists of class methods only. This makes it a global class
with a unique instance.

*/

#import <objectbase/SwarmObject.h>
#import <objc/Protocol.h>
#import <collections/List.h>
#import <defobj/Zone.h>

@interface ClassInfo: SwarmObject {
  id <List> cl;
}

+(void)initialise: (id <Zone>)aZone;	/* Should be constructed in its own
					   zone */
+(void)getClassesForProtocol: (Protocol *)p inList: (id <List>)l;

@end
