/*
    FEARLUS model0-5-1-5: LandUseHistory.m
    Copyright (C) 1999-2004  Macaulay Institute

    This file is part of FEARLUS model0-5-1-5, an agent-based model of land use
    change.

    FEARLUS model0-5-1-5 is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    FEARLUS model0-5-1-5 is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details. (LICENCE file in
    this directory.)

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Contact information:
      Gary Polhill,
      Macaulay Institute, Craigiebuckler, Aberdeen, AB15 8QH. United Kingdom
      g.polhill@macaulay.ac.uk
*/
/*


Implementation of the LandUseHistory class, a simple class for storing a single
year's data for the land use history.

*/

#import "LandUseHistory.h"

@implementation LandUseHistory

/*

initialiseWithYear:counter:

Initialise the history object. This should be called after creation, to set
up the counter and year.

*/

-(void)initialiseWithYear: (unsigned)value counter: (unsigned)c {
  counter = c;
  year = value;
}

/*

printToFile

Print information about the object to the specified file pointer.

*/

-(void)printToFile: (FILE *)fp {
  fprintf(fp, "%u\t%u", year, counter);
}

/*

getYear

Return the year that the data applies to

*/

-(unsigned)getYear {
  return(year);
}

@end
