/*
    FEARLUS model0-5-1-5: Topology.h
    Copyright (C) 1999-2004  Macaulay Institute

    This file is part of FEARLUS model0-5-1-5, an agent-based model of land use
    change.

    FEARLUS model0-5-1-5 is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    FEARLUS model0-5-1-5 is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details. (LICENCE file in
    this directory.)

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Contact information:
      Gary Polhill,
      Macaulay Institute, Craigiebuckler, Aberdeen, AB15 8QH. United Kingdom
      g.polhill@macaulay.ac.uk
*/
/*


Specification of the Topology protocol. This protocol provides methods for
searching a space within a specified radius. Basically it's about boundedness
and toroidality. Topology is probably a bit of a misnomer for this concept.

The search specifies a range of cells which may be looked in for neighbours
by the given Neighbourhood protocol object.

*/

#import "Spatial.h"

@class Coordinate2D;

@protocol Topology

+create: aZone setSize: (id <Spatial>)size Radius: (unsigned)r;
-(id <Spatial>)startSearchWithCentre: (id <Spatial>)loc;
-(BOOL)continueSearch;
-(id <Spatial>)nextSearchItem;
-(void)drop;

@end

@protocol Grid2DTopology <Topology>

+create: aZone
setSize: (id <Grid2DSpatial>)size
 Radius: (unsigned)r;
-(id <Grid2DSpatial>)startSearchWithCentre: 
  (id <Grid2DSpatial>)loc;
-(BOOL)continueSearch;
-(id <Grid2DSpatial>)nextSearchItem;
-(BOOL)getNeighbourhoodCoordinatesOf: (id <Grid2DSpatial>)loc1
			  relativeTo: (id <Grid2DSpatial>)loc2
				  in: (Coordinate2D *)coord;

@end
